// JavaScript Document

function tables()
{
	this.title			= '';
	this.columnCount	= 1;
	this.headerTitles	= '';
	this.rowCount		= 0;
	this.rows			= new Array();
	this.actualRow		= 0;
	
	this.tmplBody		= '<!doctype html>' +
'<html>' +
'<head>' +
'<meta charset="utf-8">' +
'<title>Tabulka</title>' +
'<link rel="stylesheet" href="style.css">' +
'<script src="jquery.js"></script>'+
'</head>' +
'<body>' +
'	<h1>{headline}</h1>' +
'	<table cellspacing="0">' +
'		<tr>' +
'			{headers}' +
'		</tr>' +
'		{table}' +
'	</table>' +
'</body>' +
'</html>';
	this.tmplHeaders	= '<td class="head">{headerName}</td>';
	this.tmplLine		= '<tr>{cells}</tr>';
	this.tmplCell		= '<td class="cell">{value}</td>';
	
	this.setTitle = function(title)
	{
		this.title = title;
	}
	
	this.setColumnCount = function(columnCount)
	{
		this.columnCount = columnCount;
	}
	
	this.setHeaderTitles = function(headerNames)
	{
		this.headerTitles = headerNames;
	}
	
	this.setColumnCount = function(columnCount)
	{
		this.columnCount = columnCount;
	}
	
	this.addRow = function()
	{
		if(arguments.length <= this.columnCount)
		{
			this.writeRow(arguments);
		}
	}
	
	this.addRowFromString = function(rowString)
	{
		this.writeRow(rowString.split(";"));
	}
	
	this.addRowsJson = function(json)
	{
		for(var j=0; j<json.length; j++)
		{
			if(json[j].length <= this.columnCount)
			{
				this.writeRow(json[j]);
			}
			else
			{
				var errRow = j+1;
				alert("Na " + errRow + ". řádce došlo k chybě - překročený maximální počet sloupců.");
			}
		}
	}
	
	this.writeRow = function(arr)
	{
		this.rows[this.actualRow] = arr;
		this.actualRow++;
	}
	
	//render
	this.createTable = function()
	{
		if(this.rowCount == 0)
		{
			this.rowCount = this.actualRow;
		}
		
		// vyrenderování hlavičky
		var hlavicka = '';
		for(var i=0; i<this.headerTitles.length; i++)
		{
			var hl = this.tmplHeaders;
			hlavicka += hl.replace('{headerName}', this.headerTitles[i]);
		}
		
		// vyrenderování řádků
		var radky = '';
		var bunky = '';
		
		for(var i =0; i<this.rowCount; i++)
		{
			radky += '<tr>';
			var row = this.tmplLine;
			
			for(var j=0; j<this.rows[i].length; j++)
			{
				var cell = this.tmplCell;
				bunky += cell.replace('{value}', this.rows[i][j]);
			}
			radky += bunky;
			radky += '</tr>';
			bunky = '';
		}
		
		//vyrenderování tabulky
		var tabulka = this.tmplBody;
		tabulka = tabulka.replace('{headline}', this.title);
		tabulka = tabulka.replace('{headers}', hlavicka);
		tabulka = tabulka.replace('{table}', radky);
		
		document.writeln(tabulka);
	}
	
}


/*// interakce
$('td').blur(function(e) {
	if($(this).hasClass('head'))
	{
		alert(5);
	}
});


*/
